## openocd 0.11.0~rc2

=== contrib/loaders/checksum/Makefile ===
BIN2C = ../../../src/helper/bin2char.sh

ARM_CROSS_COMPILE ?= arm-none-eabi-
ARM_AS      ?= $(ARM_CROSS_COMPILE)as
ARM_OBJCOPY ?= $(ARM_CROSS_COMPILE)objcopy

ARM_AFLAGS = -EL

arm: armv4_5_crc.inc armv7m_crc.inc

armv4_5_%.elf: armv4_5_%.s
	$(ARM_AS) $(ARM_AFLAGS) $< -o $@

armv4_5_%.bin: armv4_5_%.elf
	$(ARM_OBJCOPY) -Obinary $< $@

armv4_5_%.inc: armv4_5_%.bin
	$(BIN2C) < $< > $@

armv7m_%.elf: armv7m_%.s
	$(ARM_AS) $(ARM_AFLAGS) $< -o $@

armv7m_%.bin: armv7m_%.elf
	$(ARM_OBJCOPY) -Obinary $< $@

armv7m_%.inc: armv7m_%.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.bin *.inc

=== contrib/loaders/erase_check/Makefile ===
BIN2C = ../../../src/helper/bin2char.sh

ARM_CROSS_COMPILE ?= arm-none-eabi-
ARM_AS      ?= $(ARM_CROSS_COMPILE)as
ARM_OBJCOPY ?= $(ARM_CROSS_COMPILE)objcopy

ARM_AFLAGS = -EL

STM8_CROSS_COMPILE ?= stm8-
STM8_AS      ?= $(STM8_CROSS_COMPILE)as
STM8_OBJCOPY ?= $(STM8_CROSS_COMPILE)objcopy

STM8_AFLAGS =

arm: armv4_5_erase_check.inc armv7m_erase_check.inc

armv4_5_%.elf: armv4_5_%.s
	$(ARM_AS) $(ARM_AFLAGS) $< -o $@

armv4_5_%.bin: armv4_5_%.elf
	$(ARM_OBJCOPY) -Obinary $< $@

armv4_5_%.inc: armv4_5_%.bin
	$(BIN2C) < $< > $@

armv7m_%.elf: armv7m_%.s
	$(ARM_AS) $(ARM_AFLAGS) $< -o $@

armv7m_%.bin: armv7m_%.elf
	$(ARM_OBJCOPY) -Obinary $< $@

armv7m_%.inc: armv7m_%.bin
	$(BIN2C) < $< > $@

stm8: stm8_erase_check.inc

stm8_%.elf: stm8_%.s
	$(STM8_AS) $(STM8_AFLAGS) $< -o $@

stm8_%.bin: stm8_%.elf
	$(STM8_OBJCOPY) -Obinary $< $@

stm8_%.inc: stm8_%.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.bin *.inc

=== contrib/loaders/watchdog/Makefile ===
BIN2C = ../../../src/helper/bin2char.sh

ARM_CROSS_COMPILE ?= arm-none-eabi-
ARM_AS      ?= $(ARM_CROSS_COMPILE)as
ARM_OBJCOPY ?= $(ARM_CROSS_COMPILE)objcopy

ARM_AFLAGS = -EL -mthumb

arm: armv7m_kinetis_wdog.inc armv7m_kinetis_wdog32.inc

armv7m_%.elf: armv7m_%.s
	$(ARM_AS) $(ARM_AFLAGS) $< -o $@

armv7m_%.bin: armv7m_%.elf
	$(ARM_OBJCOPY) -Obinary $< $@

armv7m_%.inc: armv7m_%.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.bin *.inc

=== contrib/loaders/flash/cc26xx/Makefile ===
BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= arm-none-eabi-
GCC     = $(CROSS_COMPILE)gcc
OBJCOPY = $(CROSS_COMPILE)objcopy

FLAGS  = -mthumb -Os -ffunction-sections -fdata-sections -g -gdwarf-3
FLAGS += -gstrict-dwarf -Wall -fno-strict-aliasing --asm

CFLAGS = -c -I.

CC26X0_CFLAGS  = -mcpu=cortex-m3 -DDEVICE_CC26X0

CC26X2_CFLAGS  = -mcpu=cortex-m4 -DDEVICE_CC26X2

CC26X0_OBJS := \
cc26x0/flashloader.o \
cc26x0/main.o \
cc26x0/startup.o \
cc26x0/flash.o

CC26X2_OBJS := \
cc26x2/flashloader.o \
cc26x2/main.o \
cc26x2/startup.o \
cc26x2/flash.o

all: cc26x0_algo.inc cc26x2_algo.inc

cc26x0/%.o: %.c
	@echo 'Building file: $<'
	@echo 'Invoking: GNU Compiler'
	$(GCC) $(FLAGS) $(CFLAGS) $(CC26X0_CFLAGS) -o"$@" "$(shell echo $<)"
	@echo 'Finished building: $<'
	@echo ' '

cc26x2/%.o: %.c
	@echo 'Building file: $<'
	@echo 'Invoking: GNU Compiler'
	$(GCC) $(FLAGS) $(CFLAGS) $(CC26X2_CFLAGS) -o"$@" "$(shell echo $<)"
	@echo 'Finished building: $<'
	@echo ' '

cc26x0_algo.out: $(CC26X0_OBJS)
	@echo 'Building target: $@'
	@echo 'Invoking: GNU Linker'
	$(GCC) $(FLAGS) -o$@ $(CC26X0_OBJS) -Wl,-T"cc26x0/cc26x0r2f.lds"
	@echo 'Finished building target: $@'
	@echo ' '

cc26x2_algo.out: $(CC26X2_OBJS)
	@echo 'Building target: $@'
	@echo 'Invoking: GNU Linker'
	$(GCC) $(FLAGS) -o$@ $(CC26X2_OBJS) -Wl,-T"cc26x2/cc26x2r1f.lds"
	@echo 'Finished building target: $@'
	@echo ' '

%.bin: %.out
	@echo 'Building target: $@'
	@echo 'Invoking: GNU Objcopy Utility'
	$(OBJCOPY) -Obinary $< $@
	@echo 'Finished building target: $@'
	@echo ' '

%.inc: %.bin
	@echo 'Building target: $@'
	@echo 'Invoking Bin2Char Script'
	$(BIN2C) < $< > $@
	rm $< $*.out
	@echo 'Finished building target: $@'
	@echo ' '

clean:
	@echo 'Cleaning Targets and Build Artifacts'
	rm -rf *.inc *.bin *.out *.map
	rm -rf cc26x0/*.o cc26x0/*.d
	rm -rf cc26x2/*.o cc26x2/*.d
	@echo 'Finished clean'
	@echo ' '

.PRECIOUS: %.bin

.PHONY: all clean

=== contrib/loaders/flash/fespi/Makefile ===
BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= riscv64-unknown-elf-

CC=$(CROSS_COMPILE)gcc
OBJCOPY=$(CROSS_COMPILE)objcopy
OBJDUMP=$(CROSS_COMPILE)objdump

CFLAGS = -march=rv32i -mabi=ilp32 -x assembler-with-cpp -nostdlib -nostartfiles

all: fespi.inc

.PHONY: clean

%.elf: %.S
	$(CC) $(CFLAGS) $< -o $@

%.lst: %.elf
	$(OBJDUMP) -S $< > $@

%.bin: %.elf
	$(OBJCOPY) -Obinary $< $@

%.inc: %.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.lst *.bin *.inc

=== contrib/loaders/flash/stmqspi/Makefile ===
BIN2C = ../../../../src/helper/bin2char.sh

SRCS=stmqspi_erase_check.S stmqspi_crc32.S stmqspi_read.S stmqspi_write.S \
     stmoctospi_erase_check.S stmoctospi_crc32.S stmoctospi_read.S stmoctospi_write.S
OBJS=$(patsubst %.S,%.inc,$(SRCS))

CROSS_COMPILE ?= arm-none-eabi-

CC=$(CROSS_COMPILE)gcc
OBJCOPY=$(CROSS_COMPILE)objcopy
OBJDUMP=$(CROSS_COMPILE)objdump
LD=$(CROSS_COMPILE)ld

all: $(OBJS)

%.o: %.S Makefile
	$(CC) -Wall -Werror -Wa,-adhlmn -o $@ -c $< > $(@:.o=.lst)
	@enscript -Easm -T 4 -G -o - $(@:.o=.lst) | ps2pdf - $(@:.o=.pdf) || true

%.elf: %.o
	$(LD) -s -defsym=_start=0 -o $@ $<

%.bin: %.elf
	$(OBJCOPY) -S -O binary $< $@

%.inc: %.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.o *.elf *.lst *.pdf *.bin *.inc

.PHONY:	all clean

.INTERMEDIATE: $(patsubst %.S,%.o,$(SRCS)) $(patsubst %.S,%.elf,$(SRCS)) $(patsubst %.S,%.bin,$(SRCS))

=== src/jtag/drivers/OpenULINK/Makefile ===
############################################################################
#    Copyright (C) 2011 by Martin Schmoelzer                               #
#    <martin.schmoelzer@student.tuwien.ac.at>                              #
#                                                                          #
#    This program is free software; you can redistribute it and/or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program.  If not, see <http://www.gnu.org/licenses/>. #
############################################################################

# Define the name of our tools. Some distributions (e. g. Fedora) prefix
# the SDCC executables, change this accordingly!
PREFIX =

# Small Device C Compiler: http://sdcc.sourceforge.net/
CC = $(PREFIX)-sdcc

# 8051 assembler, part of the SDCC software package.
AS = $(PREFIX)-sdas8051

# SDCC produces quite messy Intel HEX files. This tool is be used to re-format
# those files. It is not required for the firmware download functionality in
# the OpenOCD driver, but the resulting file is smaller.
PACKIHX = $(PREFIX)-packihx

# GNU binutils size. Used to print the size of the IHX file generated by SDCC.
SIZE = size

# Source and header directories.
SRC_DIR     = src
INCLUDE_DIR = include

CODE_SIZE = 0x1B00

# Starting address of __xdata variables. Since the OpenULINK firmware does not
# use any of the isochronous interrupts, we can use the isochronous buffer space
# as XDATA memory.
XRAM_LOC  = 0x2000
XRAM_SIZE = 0x0800

CFLAGS  = --std-sdcc99 --opt-code-size --model-small
LDFLAGS = --code-loc 0x0000 --code-size $(CODE_SIZE) --xram-loc $(XRAM_LOC) \
          --xram-size $(XRAM_SIZE) --iram-size 256 --model-small

# list of base object files
OBJECTS = main.rel usb.rel protocol.rel jtag.rel delay.rel USBJmpTb.rel
HEADERS = $(INCLUDE_DIR)/main.h         \
          $(INCLUDE_DIR)/usb.h          \
          $(INCLUDE_DIR)/protocol.h     \
          $(INCLUDE_DIR)/jtag.h         \
          $(INCLUDE_DIR)/delay.h        \
          $(INCLUDE_DIR)/reg_ezusb.h    \
          $(INCLUDE_DIR)/io.h           \
          $(INCLUDE_DIR)/msgtypes.h

# Disable all built-in rules.
.SUFFIXES:

# Targets which are executed even when identically named file is present.
.PHONY: all, clean

all: ulink_firmware.ihx
	$(SIZE) ulink_firmware.ihx

ulink_firmware.ihx: $(OBJECTS)
	$(CC) -mmcs51 $(LDFLAGS) -o $@ $^

# Rebuild every C module (there are only 5 of them) if any header changes.
%.rel: $(SRC_DIR)/%.c $(HEADERS)
	$(CC) -c $(CFLAGS) -mmcs51 -I$(INCLUDE_DIR) -o $@ $<

%.rel: $(SRC_DIR)/%.a51
	$(AS) -lsgo $@ $<

clean:
	rm -f *.asm *.lst *.rel *.rst *.sym *.ihx *.lk *.map *.mem

hex: ulink_firmware.ihx
	$(PACKIHX) ulink_firmware.ihx > ulink_firmware.hex

=== debian/changelog ===
openocd (0.11.0~rc2-1) unstable; urgency=medium

  * Upstream release candidate
    * Remove no-longer necessary patch for external libjaylink

 -- Jonathan McDowell <noodles@earth.li>  Wed, 03 Feb 2021 12:42:03 +0000

openocd (0.11.0~rc1-2) unstable; urgency=medium

  * Add build-dep on libgpiod-dev
  * Add build-dep on libcapstone-dev
  * Lintian cleanups:
    * Remove trailing whitespace in Debian files
    * Use HTTPS in watch file
    * Move to debhelper compat level 12
    * Update Standards-Version to 4.5.1 (no further changes)
    * Add upstream metadata information
    * Minimise upstream signing key

 -- Jonathan McDowell <noodles@earth.li>  Sun, 17 Jan 2021 14:34:03 +0000

openocd (0.11.0~rc1-1) unstable; urgency=medium

  * Upstream release candidate

 -- Jonathan McDowell <noodles@earth.li>  Thu, 10 Dec 2020 10:49:42 +0000

=== debian/rules ===
#!/usr/bin/make -f

DEB_MAKE_BUILD_TARGET := all
# Also build PDF and HTML documentation if nodoc is not set
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	DEB_MAKE_BUILD_TARGET += pdf html
	DEB_CONFIGURE_EXTRA_FLAGS := \
		--enable-doxygen-pdf \
		--enable-doxygen-html
else
	DEB_CONFIGURE_EXTRA_FLAGS := \
		--disable-doxygen-pdf \
		--disable-doxygen-html
endif

DEB_CONFIGURE_EXTRA_FLAGS += \
	--disable-werror \
	--disable-internal-jimtcl \
	--disable-internal-libjaylink \
	\
	--enable-dummy \
	--enable-ep93xx \
	--enable-at91rm9200 \
	--enable-usbprog \
	--enable-vsllink \
	--enable-rlink \
	--enable-ulink \
	--enable-arm-jtag-ew \
	--enable-buspirate \
	--enable-osbdm \
	--enable-opendous \
	--enable-remote-bitbang \
	--enable-bcm2835gpio \
	--enable-sysfsgpio \
	--enable-jlink \

configure_flags_parport := \
	--enable-parport \
	--enable-parport_ppdev

ifeq ($(DEB_HOST_ARCH_OS),linux)
# Some adapters are only supported on Linux.
DEB_CONFIGURE_EXTRA_FLAGS += $(configure_flags_parport)
DEB_CONFIGURE_EXTRA_FLAGS += --enable-gw16012 \
			     --enable-amtjtagaccel \
			     --enable-ftdi \
			     --enable-stlink \
			     --enable-ti-icdi \
			     $(configure_flags_parport)
endif

ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
# Parport drivers only work on Linux and kFreeBSD, conditionally add them here.
DEB_CONFIGURE_EXTRA_FLAGS += $(configure_flags_parport) \
			     --enable-ftdi \
			     --enable-stlink \
			     --enable-ti-icdi
endif

override_dh_auto_build:
	dh_auto_build -- $(DEB_MAKE_BUILD_TARGET)

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)

%:
	dh $@

## openocd 0.11.0

=== contrib/loaders/Makefile ===
.PHONY: arm clean-arm

all: arm stm8

common_dirs = \
	checksum \
	erase_check \
	watchdog

ARM_CROSS_COMPILE ?= arm-none-eabi-

arm_dirs = \
	flash/fm4 \
	flash/kinetis_ke \
	flash/max32xxx \
	flash/xmc1xxx \
	debug/xscale

arm:
	for d in $(common_dirs); do \
		$(MAKE) -C $$d arm; \
	done
	for d in $(arm_dirs); do \
		$(MAKE) -C $$d all CROSS_COMPILE=$(ARM_CROSS_COMPILE); \
	done

clean-arm:
	for d in $(arm_dirs); do \
		$(MAKE) -C $$d clean; \
	done

clean: clean-arm
	for d in $(common_dirs); do \
		$(MAKE) -C $$d clean; \
	done

stm8:
	$(MAKE) -C erase_check stm8

=== contrib/loaders/debug/xscale/Makefile ===
BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= arm-none-eabi-

CC=$(CROSS_COMPILE)gcc
OBJCOPY=$(CROSS_COMPILE)objcopy
OBJDUMP=$(CROSS_COMPILE)objdump

CFLAGS = -static -nostartfiles -mlittle-endian -Wa,-EL
LDFLAGS = -Tdebug_handler.ld

all: debug_handler.inc

.PHONY: clean

.INTERMEDIATE: debug_handler.elf

debug_handler.elf: protocol.h

%.elf: %.S
	$(CC) $(CFLAGS) $(LDFLAGS) $< -o $@

%.lst: %.elf
	$(OBJDUMP) -S $< > $@

%.bin: %.elf
	$(OBJCOPY) -Obinary $< $@

%.inc: %.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.lst *.bin *.inc

=== contrib/loaders/flash/bluenrg-x/Makefile ===
BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= arm-none-eabi-

CC=$(CROSS_COMPILE)gcc
OBJCOPY=$(CROSS_COMPILE)objcopy
OBJDUMP=$(CROSS_COMPILE)objdump

CFLAGS =  -c -mthumb -mcpu=cortex-m0 -O3 -g

all: bluenrg-x_write.inc

.PHONY: clean

.INTERMEDIATE: bluenrg-x_write.o

%.o: %.c
	$(CC) $(CFLAGS) -Wall -Wextra -Wa,-adhln=$*.lst $< -o $@

%.bin: %.o
	$(OBJCOPY) -Obinary $< $@

%.inc: %.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.o *.lst *.bin *.inc

=== contrib/loaders/flash/cc3220sf/Makefile ===
BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= arm-none-eabi-
AS      = $(CROSS_COMPILE)as
OBJCOPY = $(CROSS_COMPILE)objcopy

all: cc3220sf.inc

%.elf: %.s
	$(AS) $< -o $@

%.bin: %.elf
	$(OBJCOPY) -Obinary $< $@

%.inc: %.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.bin *.inc

=== contrib/loaders/flash/kinetis/Makefile ===
BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= arm-none-eabi-
AS      = $(CROSS_COMPILE)as
OBJCOPY = $(CROSS_COMPILE)objcopy

all: kinetis_flash.inc

%.elf: %.s
	$(AS) $< -o $@

%.bin: %.elf
	$(OBJCOPY) -Obinary $< $@

%.inc: %.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.bin *.inc

=== contrib/loaders/flash/kinetis_ke/Makefile ===
BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= arm-none-eabi-
AS      = $(CROSS_COMPILE)as
OBJCOPY = $(CROSS_COMPILE)objcopy

AFLAGS = -EL

all: kinetis_ke_flash.inc kinetis_ke_watchdog.inc

%.elf: %.s
	$(AS) $(AFLAGS) $< -o $@

%.bin: %.elf
	$(OBJCOPY) -Obinary $< $@

%.inc: %.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.bin *.inc

=== contrib/loaders/flash/max32xxx/Makefile ===
BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= arm-none-eabi-
AS      = $(CROSS_COMPILE)as
OBJCOPY = $(CROSS_COMPILE)objcopy

all: max32xxx.inc

%.elf: %.s
	$(AS) $< -o $@

%.bin: %.elf
	$(OBJCOPY) -Obinary $< $@

%.inc: %.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.bin *.inc

=== contrib/loaders/flash/msp432/Makefile ===
BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= arm-none-eabi-
GCC     = $(CROSS_COMPILE)gcc
OBJCOPY = $(CROSS_COMPILE)objcopy

FLAGS = -mcpu=cortex-m4 -march=armv7e-m -mfloat-abi=hard -mfpu=fpv4-sp-d16 -mthumb

CFLAGS  = -c -DNO_MSP_CLASSIC_DEFINES -Dgcc -Wall -ffunction-sections
CFLAGS += -fdata-sections -std=c99 -O4

LDFLAGS = -lc -lnosys -Wl,--gc-sections

MSP432E4X_OBJS := \
msp432e4x/driverlib.o \
msp432e4x/main_msp432e4x.o \
msp432e4x/startup_msp432e4.o

MSP432P401X_OBJS := \
msp432p401x/driverlib.o \
msp432p401x/main_msp432p401x.o \
msp432p401x/startup_msp432p4.o

MSP432P411X_OBJS := \
msp432p411x/driverlib.o \
msp432p411x/main_msp432p411x.o \
msp432p411x/startup_msp432p4.o

all: msp432e4x_algo.inc msp432p401x_algo.inc msp432p411x_algo.inc

msp432e4x/%.o: %.c
	@echo 'Building file: $<'
	@echo 'Invoking: GNU Compiler'
	$(GCC) -D__MSP432E4X__ $(FLAGS) $(CFLAGS) -o"$@" "$(shell echo $<)"
	@echo 'Finished building: $<'
	@echo ' '

msp432p401x/%.o: %.c
	@echo 'Building file: $<'
	@echo 'Invoking: GNU Compiler'
	$(GCC) -D__MSP432P401X__ $(FLAGS) $(CFLAGS) -o"$@" "$(shell echo $<)"
	@echo 'Finished building: $<'
	@echo ' '

msp432p411x/%.o: %.c
	@echo 'Building file: $<'
	@echo 'Invoking: GNU Compiler'
	$(GCC) -D__MSP432P411X__ $(FLAGS) $(CFLAGS) -o"$@" "$(shell echo $<)"
	@echo 'Finished building: $<'
	@echo ' '

msp432e4x_algo.out: $(MSP432E4X_OBJS)
	@echo 'Building target: $@'
	@echo 'Invoking: GNU Linker'
	$(GCC) $(FLAGS) $(LDFLAGS) -o$@ $(MSP432E4X_OBJS) -Tmsp432e4x/msp432e4x.lds
	@echo 'Finished building target: $@'
	@echo ' '

msp432p401x_algo.out: $(MSP432P401X_OBJS)
	@echo 'Building target: $@'
	@echo 'Invoking: GNU Linker'
	$(GCC) $(FLAGS) $(LDFLAGS) -o$@ $(MSP432P401X_OBJS) -Tmsp432p401x/msp432p401x.lds
	@echo 'Finished building target: $@'
	@echo ' '

msp432p411x_algo.out: $(MSP432P411X_OBJS)
	@echo 'Building target: $@'
	@echo 'Invoking: GNU Linker'
	$(GCC) $(FLAGS) $(LDFLAGS) -o$@ $(MSP432P411X_OBJS) -Tmsp432p411x/msp432p411x.lds
	@echo 'Finished building target: $@'
	@echo ' '

%.bin: %.out
	@echo 'Building target: $@'
	@echo 'Invoking: GNU Objcopy Utility'
	$(OBJCOPY) -Obinary $< $@
	@echo 'Finished building target: $@'
	@echo ' '

%.inc: %.bin
	@echo 'Building target: $@'
	@echo 'Invoking Bin2Char Script'
	$(BIN2C) < $< > $@
	rm $< $*.out
	@echo 'Finished building target: $@'
	@echo ' '

clean:
	@echo 'Cleaning Targets and Build Artifacts'
	rm -rf *.inc *.bin *.out *.map
	rm -rf msp432e4x/*.o msp432e4x/*.d
	rm -rf msp432p401x/*.o msp432p401x/*.d
	rm -rf msp432p411x/*.o msp432p411x/*.d
	@echo 'Finished clean'
	@echo ' '

.PRECIOUS: %.bin

.PHONY: all clean

=== contrib/loaders/flash/sh_qspi/Makefile ===
CROSS_COMPILE=arm-linux-gnueabihf-
BIN2C = ../../../../src/helper/bin2char.sh

TGT = sh_qspi
ASRC += sh_qspi.S
LDS = sh_qspi.ld

OBJS += $(ASRC:.S=.o)

CC=$(CROSS_COMPILE)gcc
OBJCOPY=$(CROSS_COMPILE)objcopy
OBJDUMP=$(CROSS_COMPILE)objdump
LD=$(CROSS_COMPILE)ld
NM=$(CROSS_COMPILE)nm
SIZE=$(CROSS_COMPILE)size

CFLAGS=-Os -Wall -nostartfiles -marm -nostdinc -ffreestanding -mabi=aapcs-linux -mword-relocations -fno-pic -mno-unaligned-access -ffunction-sections -fdata-sections -fno-common -msoft-float -pipe -march=armv7-a -mtune=generic-armv7-a
LDFLAGS=-T$(LDS) -nostdlib -Map=$(TGT).map

all: $(TGT).inc

%.o: %.S
	$(CC) $(CFLAGS) -c $^ -o $@

$(TGT).elf: $(OBJS)
	$(LD) $(LDFLAGS) $^ -o $@

$(TGT).bin: $(TGT).elf
	$(OBJCOPY) $< -O binary $@
	$(NM) -n $(TGT).elf > $(TGT).sym
	$(SIZE) $(TGT).elf

$(TGT).inc: $(TGT).bin
	$(BIN2C) < $< > $@

clean:
	rm -rf *.elf *.hex *.map *.o *.disasm *.sym

=== contrib/loaders/flash/stm32/Makefile ===
BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= arm-none-eabi-

CC=$(CROSS_COMPILE)gcc
OBJCOPY=$(CROSS_COMPILE)objcopy
OBJDUMP=$(CROSS_COMPILE)objdump

CFLAGS = -static -nostartfiles -mlittle-endian -Wa,-EL

all: stm32f1x.inc stm32f2x.inc stm32h7x.inc stm32l4x.inc stm32lx.inc

.PHONY: clean

%.elf: %.S
	$(CC) $(CFLAGS) $< -o $@

%.lst: %.elf
	$(OBJDUMP) -S $< > $@

%.bin: %.elf
	$(OBJCOPY) -Obinary $< $@

%.inc: %.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.lst *.bin *.inc

=== debian/changelog ===
openocd (0.11.0-2) unstable; urgency=medium

  * Enable rshim support (Closes: #1014922)
  * Fix operation with libusb-1.0.25 onwards (Closes: #1008870)
  * Fix Tcl scripts for operation with jimtcl 0.81+ (Closes: #1014849)
  * Lintian cleanups:
    * Add missing licence in debian/copyright for Synopsys files.

 -- Jonathan McDowell <noodles@earth.li>  Wed, 20 Jul 2022 13:45:35 +0100

openocd (0.11.0-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan McDowell <noodles@earth.li>  Thu, 26 Aug 2021 10:33:35 +0100

=== debian/control ===
Source: openocd
Section: embedded
Priority: optional
Maintainer: Debian Electronics Packaging Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Jonathan McDowell <noodles@earth.li>
Build-Depends: debhelper-compat (= 12),
               libcapstone-dev,
               libftdi1-dev,
               libusb-1.0-0-dev, libusb-dev,
               libjaylink-dev (>= 0.1.0+git20200606.2800726-1~exp1),
               texinfo, texlive,
               libgpiod-dev,
               libhidapi-dev,
               libjim-dev (>= 0.81),
               pkg-config
Standards-Version: 4.5.1
Homepage: http://openocd.sourceforge.net/
Vcs-Browser: https://salsa.debian.org/electronics-team/openocd
Vcs-Git: https://salsa.debian.org/electronics-team/openocd.git
Rules-Requires-Root: no

Package: openocd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Open on-chip JTAG/SWD debug solution for embedded target devices
 OpenOCD aims to provide debugging, in-system programming and boundary-scan
 testing for embedded target devices.
 .
 The debugger uses an IEEE 1149-1 compliant JTAG TAP bus master to access
 on-chip debug functionality available on ARM based microcontrollers or
 system-on-chip solutions. For MIPS systems the EJTAG interface is supported.
 Additionally there is support for eSi-RISC, Intel, OpenRISC, RISC-V and ARC
 controllers.
 .
 User interaction is realized through a telnet command line interface,
 a gdb (the GNU debugger) remote protocol server, and a simplified RPC
 connection that can be used to interface with OpenOCD's Jim Tcl engine.
 .
 OpenOCD supports many different types of JTAG interfaces/programmers.

## openocd 0.12.0~rc1

=== debian/changelog ===
openocd (0.12.0~rc1-1) unstable; urgency=medium

  * Upstream release candidate
    * Update remove-jimtcl-configure.patch
    * Remove libusb/jimtcl patches taken from upstream
    * Update debian/copyright

 -- Jonathan McDowell <noodles@earth.li>  Sat, 24 Sep 2022 10:38:23 +0100

## openocd 0.12.0~rc2

=== debian/changelog ===
openocd (0.12.0~rc2-1) unstable; urgency=medium

  * Upstream release candidate

 -- Jonathan McDowell <noodles@earth.li>  Wed, 26 Oct 2022 21:06:51 +0100

## openocd 0.12.0

=== contrib/loaders/erase_check/Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+# SPDX-License-Identifier: GPL-2.0-or-later
+
 BIN2C = ../../../src/helper/bin2char.sh
 
 ARM_CROSS_COMPILE ?= arm-none-eabi-

=== contrib/loaders/watchdog/Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+# SPDX-License-Identifier: GPL-2.0-or-later
+
 BIN2C = ../../../src/helper/bin2char.sh
 
 ARM_CROSS_COMPILE ?= arm-none-eabi-

=== contrib/loaders/flash/bluenrg-x/Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+# SPDX-License-Identifier: GPL-2.0-or-later
+
 BIN2C = ../../../../src/helper/bin2char.sh
 
 CROSS_COMPILE ?= arm-none-eabi-

=== contrib/loaders/flash/cc3220sf/Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+# SPDX-License-Identifier: GPL-2.0-or-later
+
 BIN2C = ../../../../src/helper/bin2char.sh
 
 CROSS_COMPILE ?= arm-none-eabi-

=== contrib/loaders/flash/fespi/Makefile ===
# SPDX-License-Identifier: GPL-2.0-or-later

BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= riscv64-unknown-elf-

RISCV_CC=$(CROSS_COMPILE)gcc
RISCV_OBJCOPY=$(CROSS_COMPILE)objcopy
RISCV_OBJDUMP=$(CROSS_COMPILE)objdump

CFLAGS = -nostdlib -nostartfiles -Wall -Werror -Os -fPIC -Wunused-result -g
RISCV32_CFLAGS = -march=rv32e -mabi=ilp32e $(CFLAGS)
RISCV64_CFLAGS = -march=rv64i -mabi=lp64 $(CFLAGS)

all: riscv32_fespi.inc riscv64_fespi.inc

.PHONY: clean

# .c -> .o
riscv32_%.o:  riscv_%.c
	$(RISCV_CC) -c $(RISCV32_CFLAGS) $^ -o $@

riscv64_%.o:  riscv_%.c
	$(RISCV_CC) -c $(RISCV64_CFLAGS) $< -o $@

# .S -> .o
riscv32_%.o:  riscv_%.S
	$(RISCV_CC) -c $(RISCV32_CFLAGS) $^ -o $@

riscv64_%.o:  riscv_%.S
	$(RISCV_CC) -c $(RISCV64_CFLAGS) $^ -o $@

# .o -> .elf
riscv32_%.elf:	riscv32_%.o riscv32_wrapper.o
	$(RISCV_CC) -T riscv.lds $(RISCV32_CFLAGS) $^ -o $@

riscv64_%.elf:	riscv64_%.o riscv64_wrapper.o
	$(RISCV_CC) -T riscv.lds $(RISCV64_CFLAGS) $^ -o $@

# .elf -> .bin
%.bin: %.elf
	$(RISCV_OBJCOPY) -Obinary $< $@

# .bin -> .inc
%.inc: %.bin
	$(BIN2C) < $< > $@

# utility
%.lst: %.elf
	$(RISCV_OBJDUMP) -S $< > $@

clean:
	-rm -f *.elf *.o *.lst *.bin *.inc

=== contrib/loaders/flash/gd32vf103/Makefile ===
# SPDX-License-Identifier: GPL-2.0-or-later

BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= riscv-none-embed-

CC=$(CROSS_COMPILE)gcc
OBJCOPY=$(CROSS_COMPILE)objcopy
OBJDUMP=$(CROSS_COMPILE)objdump

CFLAGS = -march=rv32i -mabi=ilp32 -static -nostartfiles -nostdlib -Os -g -fPIC

all: gd32vf103.inc

.PHONY: clean

%.elf: %.c
	$(CC) $(CFLAGS) $< -o $@

%.lst: %.elf
	$(OBJDUMP) -S $< > $@

%.bin: %.elf
	$(OBJCOPY) -Obinary $< $@

%.inc: %.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.lst *.bin *.inc

=== contrib/loaders/flash/kinetis/Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+# SPDX-License-Identifier: GPL-2.0-or-later
+
 BIN2C = ../../../../src/helper/bin2char.sh
 
 CROSS_COMPILE ?= arm-none-eabi-

=== contrib/loaders/flash/max32xxx/Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+# SPDX-License-Identifier: GPL-2.0-or-later
+
 BIN2C = ../../../../src/helper/bin2char.sh
 
 CROSS_COMPILE ?= arm-none-eabi-

=== contrib/loaders/flash/msp432/Makefile ===
--- 
+++ 
@@ -1,3 +1,7 @@
+# SPDX-License-Identifier: BSD-3-Clause
+
+# Copyright (C) 2018 Texas Instruments Incorporated - http://www.ti.com/
+
 BIN2C = ../../../../src/helper/bin2char.sh
 
 CROSS_COMPILE ?= arm-none-eabi-

=== contrib/loaders/flash/nrf5/Makefile ===
# SPDX-License-Identifier: GPL-2.0-or-later

BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= arm-none-eabi-

CC=$(CROSS_COMPILE)gcc
OBJCOPY=$(CROSS_COMPILE)objcopy
OBJDUMP=$(CROSS_COMPILE)objdump

CFLAGS = -static -nostartfiles -mlittle-endian -Wa,-EL

all: nrf5.inc

.PHONY: clean

%.elf: %.S
	$(CC) $(CFLAGS) $< -o $@

%.lst: %.elf
	$(OBJDUMP) -S $< > $@

%.bin: %.elf
	$(OBJCOPY) -Obinary $< $@

%.inc: %.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.lst *.bin *.inc

=== contrib/loaders/flash/rsl10/Makefile ===
# SPDX-License-Identifier: GPL-2.0-or-later

BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= arm-none-eabi-

CC=$(CROSS_COMPILE)gcc
OBJCOPY=$(CROSS_COMPILE)objcopy
OBJDUMP=$(CROSS_COMPILE)objdump

CFLAGS = -static -nostartfiles -mlittle-endian -Wa,-EL

all: rom_launcher.inc

.PHONY: clean

%.elf: %.S
	$(CC) $(CFLAGS) $< -o $@

%.lst: %.elf
	$(OBJDUMP) -S $< > $@

%.bin: %.elf
	$(OBJCOPY) -Obinary $< $@

%.inc: %.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.lst *.bin *.inc

=== contrib/loaders/flash/stm32/Makefile ===
# SPDX-License-Identifier: GPL-2.0-or-later

BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= arm-none-eabi-

CC=$(CROSS_COMPILE)gcc
OBJCOPY=$(CROSS_COMPILE)objcopy
OBJDUMP=$(CROSS_COMPILE)objdump


AFLAGS = -static -nostartfiles -mlittle-endian -Wa,-EL
CFLAGS = -c -mthumb -nostdlib -nostartfiles -Os -g -fPIC

all: stm32f1x.inc stm32f2x.inc stm32h7x.inc stm32l4x.inc stm32lx.inc

.PHONY: clean

%.elf: %.S
	$(CC) $(AFLAGS) $< -o $@

stm32l4x.elf: stm32l4x.c
	$(CC) $(CFLAGS) -mcpu=cortex-m0plus -fstack-usage -Wa,-adhln=$(<:.c=.lst) $< -o $@

%.lst: %.elf
	$(OBJDUMP) -S $< > $@

%.bin: %.elf
	$(OBJCOPY) -Obinary $< $@

%.inc: %.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.lst *.bin *.inc

=== debian/changelog ===
openocd (0.12.0-3) unstable; urgency=medium

  * Fix build with jimtcl 0.83 (Closes: #1082908)

 -- Jonathan McDowell <noodles@earth.li>  Thu, 03 Oct 2024 08:57:48 +0100

openocd (0.12.0-2) unstable; urgency=medium

  * Disable libgpiod backend (Closes: #1070885)
  * Update pkg-config -> pkgconf in build-deps

 -- Jonathan McDowell <noodles@earth.li>  Fri, 30 Aug 2024 08:23:51 +0100

openocd (0.12.0-1) unstable; urgency=medium

  * New upstream release
  * Drop libusb-dev build-dep (thanks to Paul Fertser for pointing this
    out)
  * Update to debhelper-compat level 13
  * Switch to plain globs for filenames in debian/copyright
  * Bump Standards-Version to 4.6.2

 -- Jonathan McDowell <noodles@earth.li>  Mon, 16 Jan 2023 18:22:41 +0000

openocd (0.12.0~rc3-1) unstable; urgency=medium

  * Upstream release candidate

 -- Jonathan McDowell <noodles@earth.li>  Thu, 22 Dec 2022 14:19:29 +0000

=== debian/rules ===
--- 
+++ 
@@ -18,21 +18,22 @@
 	--disable-internal-jimtcl \
 	--disable-internal-libjaylink \
 	\
+	--enable-arm-jtag-ew \
+	--enable-at91rm9200 \
+	--enable-bcm2835gpio \
+	--enable-buspirate \
 	--enable-dummy \
 	--enable-ep93xx \
-	--enable-at91rm9200 \
+	--enable-jlink \
+	--enable-opendous \
+	--enable-osbdm \
+	--enable-remote-bitbang \
+	--enable-rlink \
+	--enable-rshim \
+	--enable-sysfsgpio \
+	--enable-ulink \
 	--enable-usbprog \
 	--enable-vsllink \
-	--enable-rlink \
-	--enable-ulink \
-	--enable-arm-jtag-ew \
-	--enable-buspirate \
-	--enable-osbdm \
-	--enable-opendous \
-	--enable-remote-bitbang \
-	--enable-bcm2835gpio \
-	--enable-sysfsgpio \
-	--enable-jlink \
 
 configure_flags_parport := \
 	--enable-parport \

=== debian/watch ===
version=3
opts=uversionmangle=s/-(rc\d*)$/~$1/,pgpsigurlmangle=s/$/.sig/ \
   https://qa.debian.org/watch/sf.php/openocd/ \
   (?:|.*/)openocd(?:[_\-]v?|)(\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## openocd 0.12.0+rpt20250716.04ae2c329

=== contrib/firmware/angie/c/Makefile ===
# SPDX-License-Identifier: GPL-2.0-or-later
#****************************************************************************
#   File : Makefile                                                         *
#   Contents : Code for NanoXplore USB-JTAG ANGIE adapter hardware.         *
#   Based on openULINK project by: Martin Schmoelzer.                       *
#   Copyright 2023, Ahmed Errached BOUDJELIDA, NanoXplore SAS.              *
#   <aboudjelida@nanoxplore.com>                                            *
#	<ahmederrachedbjld@gmail.com>											*
# ***************************************************************************/

# Define the name of tools.
PREFIX =

# Small Device C Compiler: http://sdcc.sourceforge.net/
CC = $(PREFIX)sdcc

# 8051 assembler, part of the SDCC software package.
AS = $(PREFIX)sdas8051

# SDCC produces quite messy Intel HEX files. This tool is be used to re-format
# those files. It is not required for the firmware download functionality in
# the OpenOCD driver, but the resulting file is smaller.
PACKIHX = $(PREFIX)packihx

# GNU binutils size. Used to print the size of the IHX file generated by SDCC.
SIZE = size

# Source and header directories.
SRC_DIR     = src
INCLUDE_DIR = include

CODE_SIZE = 0x3C00
XRAM_LOC  = 0x3C00
XRAM_SIZE = 0x0400

CFLAGS  = --std-sdcc99 --opt-code-size --model-small
LDFLAGS = --code-loc 0x0000 --code-size $(CODE_SIZE) --xram-loc $(XRAM_LOC) \
          --xram-size $(XRAM_SIZE) --iram-size 256 --model-small

# list of base object files
OBJECTS = main.rel usb.rel protocol.rel jtag.rel delay.rel USBJmpTb.rel serial.rel gpif.rel i2c.rel
HEADERS = $(INCLUDE_DIR)/usb.h          \
          $(INCLUDE_DIR)/protocol.h     \
          $(INCLUDE_DIR)/jtag.h         \
          $(INCLUDE_DIR)/delay.h        \
          $(INCLUDE_DIR)/reg_ezusb.h    \
          $(INCLUDE_DIR)/io.h           \
          $(INCLUDE_DIR)/serial.h       \
          $(INCLUDE_DIR)/fx2macros.h    \
          $(INCLUDE_DIR)/msgtypes.h     \
          $(INCLUDE_DIR)/i2c.h

# Disable all built-in rules.
.SUFFIXES:

# Targets which are executed even when identically named file is present.
.PHONY: all, clean

all: angie_firmware.ihx
	$(SIZE) angie_firmware.ihx

angie_firmware.ihx: $(OBJECTS)
	$(CC) -mmcs51 $(LDFLAGS) -o $@ $^

# Rebuild every C module (there are only 8 of them) if any header changes.
%.rel: $(SRC_DIR)/%.c $(HEADERS)
	$(CC) -c $(CFLAGS) -mmcs51 -I$(INCLUDE_DIR) -o $@ $<

%.rel: $(SRC_DIR)/%.a51
	$(AS) -lsgo $@ $<

clean:
	rm -f *.asm *.lst *.rel *.rst *.sym *.ihx *.lk *.map *.mem

bin: angie_firmware.ihx
	makebin -p angie_firmware.ihx angie_firmware.bin

hex: angie_firmware.ihx
	$(PACKIHX) angie_firmware.ihx > fx2.hex

=== contrib/loaders/flash/dw-spi/Makefile ===
# SPDX-License-Identifier: GPL-2.0-or-later

TOOLCHAIN:=mipsel-linux-gnu-
CC:=$(TOOLCHAIN)gcc
OBJCOPY:=$(TOOLCHAIN)objcopy
CFLAGS:=-O2 -Wall -Wextra -fpic -Wno-int-to-pointer-cast
SRC=dw-spi.c
OBJ=$(patsubst %.c, %.o,$(SRC))

# sparx-iv
ifeq ($(TOOLCHAIN),mipsel-linux-gnu-)
	CFLAGS+= -march=24kec
endif

all: \
	$(TOOLCHAIN)transaction.inc \
	$(TOOLCHAIN)erase.inc \
	$(TOOLCHAIN)check_fill.inc \
	$(TOOLCHAIN)program.inc \
	$(TOOLCHAIN)read.inc

$(TOOLCHAIN)%.bin: $(OBJ)
	$(OBJCOPY) --dump-section .$*=$@ $<

%.inc: %.bin
	xxd -i > $@ < $<

.PHONY: clean
clean:
	rm -rf .ccls-cache
	find . \( \
	-iname "*.o" \
	-o -iname "*.bin" \
	-o -iname "*.inc" \
	\) -delete

=== contrib/loaders/flash/numicro/Makefile ===
# SPDX-License-Identifier: GPL-2.0-or-later

BIN2C = ../../../../src/helper/bin2char.sh

CROSS_COMPILE ?= arm-none-eabi-

CC=$(CROSS_COMPILE)gcc
OBJCOPY=$(CROSS_COMPILE)objcopy
OBJDUMP=$(CROSS_COMPILE)objdump


AFLAGS = -static -nostartfiles -mlittle-endian -Wa,-EL

all: numicro_m0.inc numicro_m4.inc

.PHONY: clean

%.elf: %.S
	$(CC) $(AFLAGS) $< -o $@

%.lst: %.elf
	$(OBJDUMP) -S $< > $@

%.bin: %.elf
	$(OBJCOPY) -Obinary $< $@

%.inc: %.bin
	$(BIN2C) < $< > $@

clean:
	-rm -f *.elf *.lst *.bin *.inc

=== debian/changelog ===
openocd (0.12.0+rpt20250716.04ae2c329-1) trixie; urgency=medium

  * New upstream version 0.12.0+rpt20250716.04ae2c329
  * Update gbp.conf
  * Update package metadata
  * Remove rejected patches
  * Refresh patches

 -- Serge Schneider <serge@raspberrypi.com>  Wed, 16 Jul 2025 15:06:51 +0100

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,18 @@
 Source: openocd
 Section: embedded
 Priority: optional
-Maintainer: Debian Electronics Packaging Team <pkg-electronics-devel@lists.alioth.debian.org>
-Uploaders: Jonathan McDowell <noodles@earth.li>
-Build-Depends: debhelper-compat (= 12),
+Maintainer: Serge Schneider <serge@raspberrypi.com>
+Build-Depends: debhelper-compat (= 13),
                libcapstone-dev,
                libftdi1-dev,
-               libusb-1.0-0-dev, libusb-dev,
+               libusb-1.0-0-dev,
                libjaylink-dev (>= 0.1.0+git20200606.2800726-1~exp1),
                texinfo, texlive,
-               libgpiod-dev,
                libhidapi-dev,
                libjim-dev (>= 0.81),
-               pkg-config
-Standards-Version: 4.5.1
-Homepage: http://openocd.sourceforge.net/
-Vcs-Browser: https://salsa.debian.org/electronics-team/openocd
-Vcs-Git: https://salsa.debian.org/electronics-team/openocd.git
+               pkgconf
+Standards-Version: 4.6.2
+Homepage: https://github.com/raspberrypi/openocd
 Rules-Requires-Root: no
 
 Package: openocd

=== debian/watch ===
version=4

opts="mode=git, gitmode=full, gitmodules, pgpmode=none, pretty=0.12.0+rpt%cd.%h, repack, compression=xz" \
 https://github.com/raspberrypi/openocd.git \
 heads/rpi-common
